// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.    
//----------------------------------------------------------//                        
//                ━▣━━◤HSPE◢━━▣━           \\
//                                                                  //
//         •Made in    : Indonesia                  \\
//         •Create By : @_wanzss                //
//         •Xbox         :  Harringtonlყ            //
//         •Youtube   : Wanze'ϡ                    \\
//          ⌜                                             ⌝        //
//                      🅿🅻🅴🅰🆂🅴,                   \\
//               🅟🅔🅡🅜🅘🅢🅢🅘🅞🅝            //
//            🅵🅸🆁🆂🆃 🅱🅴🅵🅾🆁🅴          \\
//                🅣🅐🅚🅘🅝🅖 🅣🅗🅔               //
//                          🅲🅾🅳🅴                         \\           
//         ⌞                                              ⌟         //
//                                                                  \\
//----------------------------------------------------------\\
#include "fragmentVersionCentroid.h"

#if __VERSION__ >= 300
	#ifndef BYPASS_PIXEL_SHADER
		#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
			_centroid in highp vec2 uv0;
			_centroid in highp vec2 uv1;
		#else
			_centroid in vec2 uv0;
			_centroid in vec2 uv1;
		#endif
	#endif
#else
	#ifndef BYPASS_PIXEL_SHADER
		varying vec2 uv0;
		varying vec2 uv1;
	#endif
#endif

varying vec4 color;
varying highp vec3 wpos;
varying highp vec3 poss;
varying highp vec3 look;
varying highp vec3 screen;

uniform vec2 FOG_CONTROL;
uniform vec4 FOG_COLOR;
uniform float RENDER_DISTANCE;
uniform float FAR_CHUNKS_DISTANCE;

#ifdef FOG
varying vec4 fogColor;
#endif

#include "uniformShaderConstants.h"
#include "util.h"
#include ".room.h"
#include ".function.h"
#include ".struct.h"

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;
LAYOUT_BINDING(1) uniform sampler2D TEXTURE_1;
LAYOUT_BINDING(2) uniform sampler2D TEXTURE_2;

void main(){
#ifdef BYPASS_PIXEL_SHADER
	gl_FragColor = vec4(0, 0, 0, 0);
	return;
#else 

#if USE_TEXEL_AA
	v4 HSdiff = texture2D_AA(TEXTURE_0, uv0);
#else
	v4 HSdiff = texture2D(TEXTURE_0, uv0);
#endif

#ifdef SEASONS_FAR
	HSdiff.a = 1.;
#endif

#if USE_ALPHA_TEST
	#ifdef ALPHA_TO_COVERAGE
	#define ALPHA_THRESHOLD .01
	#else
	#define ALPHA_THRESHOLD .1
	#endif
	if(HSdiff.a < ALPHA_THRESHOLD)
		discard;
#endif
	
vec4 inColor = color;

float shy = uv1.y;
float shx = uv1.x;
float timeset = texture2D(TEXTURE_1, vec2(.0, 1.)).r;

highp vec2 fcc = FOG_CONTROL;
highp vec3 fv = sqrt(1.3*inColor.rgb);
highp vec4 fc = FOG_COLOR;

timeset = clamp((timeset-.5) * 2., 0., 1.);
detection at;
at.day = timeset;
at.night = 1.-timeset;
at.dusk = .5-abs(.5-timeset);
at.rain = (1.-pow(fcc.y, 11.));
at.cave = 1.-shy;
at.morning = pow(max(min(1.-fc.b*1.2,1.), 0.),.5);
at.midnight = pow(max(min(1.-fc.r*1.5,1.),.0),1.2);

at.day *= shy;
at.night *= shy;
at.dusk *= shy;
at.rain *= shy;
at.morning *= shy;
at.midnight *= shy;

bool isLeaves = (color.a == 0.);
bool isGrass = (color.g > color.r);
bool isWater = (color.b + color.b > color.r + color.g);
bool isUnderWater = (fcc.x == 0.);
bool isNether = (FOG_COLOR.r > FOG_COLOR.b && FOG_COLOR.r < .5 && FOG_COLOR.b < .2);
bool isTheEnd = (FOG_COLOR.r > FOG_COLOR.g && FOG_COLOR.b > FOG_COLOR.g && FOG_COLOR.r < .05 && FOG_COLOR.b < .05 && FOG_COLOR.g < .05);

#if defined(BLEND)
	HSdiff.a *= inColor.a;
#endif

#if !defined(ALWAYS_LIT)
	HSdiff *= texture2D( TEXTURE_1, uv1 );
#endif

#ifndef SEASONS
	#if !USE_ALPHA_TEST && !defined(BLEND)
		HSdiff.a = inColor.a;
	#endif
  HSdiff.rgb *= mix(inColor.rgb,fv,at.cave);
   #else
	vec2 uv = inColor.xy;
	HSdiff.rgb *= mix(vec3(1.0,1.0,1.0), texture2D( TEXTURE_2, uv).rgb*2.0, inColor.b);
	HSdiff.rgb *= inColor.aaa;
	HSdiff.a = 1.;
#endif

highp float nolight;
highp float lightUp = pow(shx*.96,2.7);
highp float shside =color.g+.7*(color.g-color.b);

highp vec3 R = normalize(cross(ddx(wpos),ddy(wpos)));

nolight = mix(1.,.35,at.day);
nolight = mix(nolight,1.4,at.cave);
nolight = mix(nolight, 1.8, at.rain);
nolight = mix(nolight,1.45,at.night);

COLORING clr;
clr.inWorld = mix(vec3(1.7), vec3(1.1,1.05,1.), at.day);
clr.inWorld = mix(clr.inWorld, vec3(5.), at.rain);
clr.inWorld = mix(clr.inWorld, vec3(2.5), at.night);
clr.inWorld = mix(clr.inWorld, vec3(1.,.1,-.5), at.dusk);
clr.inWorld = mix(clr.inWorld, vec3(1.), at.cave);
clr.inNether = vec3(1.2);
clr.inTheEnd = vec3(.7,1.4,1.5);
clr.Water = mix(vec3(.0,.535,.9), vec3(.0,.3,.7), at.dusk);
clr.Water = mix(clr.Water, vec3(.1, 1., 1.75), at.rain);
clr.Water = mix(clr.Water, vec3(.05, .15, .5), at.night);
clr.Water = mix(clr.Water, vec3(.0,.1,.2), at.cave);
clr.Shadows = vec3(.925)+shx*vec3(.086);
clr.Shadows = mix(clr.Shadows, vec3(1.), at.night);
clr.Shadows = mix(clr.Shadows, vec3(1.), at.rain);
clr.Shadows = mix(clr.Shadows, vec3(.97), at.dusk);
clr.Grayscale = HSS(HSdiff.rgb,mix(1.,-.5, at.rain));
clr.Leaves = vec3(1.2,1.3,1.2);
clr.Exposure = vec3(1.2);
clr.underWater = vec3(1.5);
clr.SeaLantern = vec3(.0, 2.8, 3.);
clr.Grass = vec3(.78);
clr.Torch = vec3(1.1, .2, -.8)*lightUp*nolight;
clr.Distpos = inColor.a * (length(wpos) /   RENDER_DISTANCE * +.7);

HSdiff.rgb = HSTM(HSdiff.rgb);
HSdiff.rgb = HSS(HSdiff.rgb, 1.75);
HSdiff.rgb *= clr.inWorld;
HSdiff.rgb *= mix(vec3(1.), clr.Grayscale, at.rain);
HSdiff.rgb *= mix(vec3(1.), clr.Exposure, at.morning);

if(isNether == ON){
HSdiff.rgb *= clr.inNether;
highp float FogNthr = clamp(length(wpos)/RENDER_DISTANCE* 1.,.3,2.);
highp vec3 FogNthrON = mix(HSdiff.rgb, fc.rgb*vec3(1.6,.5,.1),FogNthr);
HSdiff.rgb = FogNthrON;}

if(isTheEnd == ON){
clr.Torch *=.0;
highp vec3 TorchEnd = vec3(.2,.0,.7)*pow(shx*1.5,2.);
HSdiff.rgb += TorchEnd;}

if(isLeaves == ON){
HSdiff.rgb *= clr.Leaves;
shside = color.g*1.2;
clr.Shadows = vec3(.89)+shx*vec3(.16);}

if((.866>shy)||(.604>shside)){
HSdiff.rgb *= clr.Shadows;}
if((.867>shy)||(.608>shside)){
HSdiff.rgb *= clr.Shadows;}
if((.868>shy)||(.6012>shside)){
HSdiff.rgb *= clr.Shadows;}
if((.869>shy)||(.616>shside)){
HSdiff.rgb *= clr.Shadows;}
if((.87>shy)||(.62>shside)){
HSdiff.rgb *= clr.Shadows;}
if((.871>shy)||(.624>shside)){
HSdiff.rgb *= clr.Shadows;}
if((.873>shy)||(.628>shside)){
HSdiff.rgb *= clr.Shadows;}
if((.874>shy)||(.632>shside)){
HSdiff.rgb *= clr.Shadows;}

#ifndef SEASONS
if(isWater == ON){
HSdiff.a -=.2;
HSdiff.rgb = clr.Water;
HSdiff.a += clr.Distpos;}
#endif

if(at.rain < .2){
HSdiff.rgb = mix(HSdiff.rgb,raySun(wpos,HSdiff.rgb),.025*at.dusk*max(.0,R.y));}

if(!(isUnderWater == ON)){
HSdiff.rgb += clr.Torch;}else{
HSdiff.rgb = HSS(HSdiff.rgb, 1.6);
HSdiff.rgb += clr.SeaLantern*pow(shx*.35,1.5);
HSdiff.rgb *= clr.underWater;}

if(isGrass == ON){
HSdiff.rgb *= clr.Grass;}

FOGGY fog;
fog.Atmosphere = clamp(length(-wpos) / RENDER_DISTANCE * 1.,.025,.2);
fog.AtmosphereON = mix(HSdiff.rgb, fc.rgb, fog.Atmosphere);
HSdiff.rgb = fog.AtmosphereON;

fog.foggyRain = clamp(length(-wpos) / RENDER_DISTANCE *1.2,.0,3.);
fog.foggyRainON = mix(HSdiff.rgb, fc.rgb*vec3(2.), fog.foggyRain);
HSdiff.rgb = mix(HSdiff.rgb, fog.foggyRainON, at.rain);

fog.foggyDusk = clamp(length(wpos) / RENDER_DISTANCE *1.4, .15, 1.);
fog.foggyDuskON = mix(HSdiff.rgb, fc.rgb, fog.foggyDusk);
HSdiff.rgb = mix(HSdiff.rgb, fog.foggyDuskON, at.morning);

fog.foggyNight = clamp(length(wpos) / FAR_CHUNKS_DISTANCE * .1, .4, 1.5);
fog.foggyNightON = mix(HSdiff.rgb, fc.rgb, fog.foggyNight);
HSdiff.rgb = mix(HSdiff.rgb, fog.foggyNightON, at.midnight);

#ifdef FOG
HSdiff.rgb = mix( HSdiff.rgb, fogColor.rgb, fogColor.a);
#endif

gl_FragColor = HSdiff;

#endif // BYPASS_PIXEL_SHADER
}